namespace Angelus.Data.Linq.OracleClient
{
    using System.Collections;
    using System.Collections.Generic;

    /// <summary>
    /// 
    /// </summary>
    /// <typeparam name="T"></typeparam>
    internal class EnumerableStoredProcedureResults<T> : IEnumerable<T>
    {
        #regionFields

        private readonly bool _multipleResults;
        private readonly OracleStoredProcedureResultImpl _result;
        private bool _hasBeenEnumerated;

        #endregionFields

        #regionConstructors

        /// <summary>
        /// 
        /// </summary>
        /// <param name="result"></param>
        /// <param name="multipleResults"></param>
        internal EnumerableStoredProcedureResults(OracleStoredProcedureResultImpl result, bool multipleResults)
        {
            this._result = result;
            this._multipleResults = multipleResults;
        }

        #endregionConstructors

        #regionIEnumerable Overrides

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public IEnumerator<T> GetEnumerator()
        {
            if (this._hasBeenEnumerated)
            {
                this._result.Reset();
            }
            this._hasBeenEnumerated = true;
            return this._result.GetResultsImpl<T>(this._multipleResults);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        IEnumerator IEnumerable.GetEnumerator()
        {
            return this.GetEnumerator();
        }

        #endregionMethods
    }
}