Option Explicit

Dim vbCrLf
vbCrLf = Chr(13) & Chr(10)

Dim Shell
Set Shell = CreateObject("WScript.Shell")

If ShutdownUndesirableProcesses() > 1 Then
    WScript.Quit
End If

Dim PromptText
PromptText = "Project LINQ introduces several changes to the C# language. LINQ" & vbCrLf & _
             "C# is not valid C# for Visual Studio 2005. The result is that editing" & vbCrLf & _
             "LINQ C# code is problematic as there is no IntelliSense(TM) for the new" & vbCrLf & _
             "features, errors are incorrectly reported in the output window, and the" & vbCrLf & _
             "code editor underlines valid LINQ code with red squiggles. A special" & vbCrLf & _
             "language service was created to help alleviate these problems." & vbCrLf & _
             vbCrLf & _
             "Do you want to uninstall LINQ Enabled C# IDE Support now?"

Select Case Shell.Popup(PromptText, 0, "Uninstall LINQ Enabled C# IDE Support", vbYesNo + vbQuestion)
    Case 6
        Dim FileSystem
        Set FileSystem = CreateObject("Scripting.FileSystemObject")

        If Not RegCheck("HKLM\Software\Microsoft\LINQ Preview\VCSPKGDIR") Or _
            Not RegCheck("HKLM\Software\Microsoft\LINQ Preview\VCSIDEDIR") Then
            Shell.Popup "Cannot find registry keys needed to restore Visual C# 2005 IDE." & vbCrLf & _
                        "Please repair .NET Language Integrated Query, May 2006 CTP.", _
                        0, "Uninstall LINQ Enabled C# IDE Support", vbCritical
            WScript.Quit
        End If

        Dim VCSPkgDir
        VCSPkgDir = Shell.RegRead("HKLM\Software\Microsoft\LINQ Preview\VCSPKGDIR")

        Dim VCSIDEDir
        VCSIDEDir = Shell.RegRead("HKLM\Software\Microsoft\LINQ Preview\VCSIDEDIR")

        If Not FileSystem.FileExists(VCSPkgDir & "cslangsvc.dll.backup") Or _
            Not FileSystem.FileExists(VCSPkgDir & "1033\cslangsvcui.dll.backup") Or _
            Not FileSystem.FileExists(VCSIDEDir & "Microsoft.VisualStudio.CSharp.Options.dll.backup") Or _
            Not FileSystem.FileExists(VCSIDEDir & "Microsoft.VisualStudio.CSharp.Services.Language.dll.backup") Then

            Shell.Popup "Cannot find backup files in order to restore Visual C# 2005 IDE." & vbCrLf & _
                        "Please uninstall .NET Language Integrated Query, May 2006 CTP and repair Visual Studio 2005.", _
                        0, "Uninstall LINQ Enabled C# IDE Support", vbCritical
            WScript.Quit
        End If

        If RestoreFile(VCSPkgDir & "cslangsvc.dll") = 0 Then
            If RestoreFile(VCSPkgDir & "1033\cslangsvcui.dll") = 0 Then
                If RestoreFile(VCSIDEDir & "Microsoft.VisualStudio.CSharp.Options.dll") = 0 Then
                    If RestoreFile(VCSIDEDir & "Microsoft.VisualStudio.CSharp.Services.Language.dll") = 0 Then
                        On Error Resume Next
                        FileSystem.DeleteFile VCSPkgDir & "cslangsvc.dll" & ".tmp", True
                        FileSystem.DeleteFile VCSPkgDir & "1033\cslangsvcui.dll" & ".tmp", True
                        FileSystem.DeleteFile VCSIDEDir & "Microsoft.VisualStudio.CSharp.Options.dll" & ".tmp", True
                        FileSystem.DeleteFile VCSIDEDir & "Microsoft.VisualStudio.CSharp.Services.Language.dll" & ".tmp", True
                        On Error Goto 0
            
                        Shell.RegWrite("HKLM\Software\Microsoft\LINQ Preview\CSLangSvcUpdated"), "0"

                        Shell.Popup "LINQ Enabled C# IDE Support has been uninstalled successfully.", 0, "Uninstall LINQ Enabled C# IDE Support", vbInformation
                        WScript.Quit
                    End If
                    On Error Resume Next
                    FileSystem.CopyFile VCSIDEDir & "Microsoft.VisualStudio.CSharp.Services.Language.dll" & ".tmp", VCSIDEDir & "Microsoft.VisualStudio.CSharp.Services.Language.dll", True
                    On Error Goto 0
                End If
                On Error Resume Next
                FileSystem.CopyFile VCSIDEDir & "Microsoft.VisualStudio.CSharp.Options.dll" & ".tmp", VCSIDEDir & "Microsoft.VisualStudio.CSharp.Options.dll", True
                On Error Goto 0
            End If
            On Error Resume Next
            FileSystem.CopyFile VCSPkgDir & "1033\cslangsvcui.dll" & ".tmp", VCSPkgDir & "1033\cslangsvcui.dll", True
            On Error Goto 0
        End If
        On Error Resume Next
        FileSystem.CopyFile VCSPkgDir & "cslangsvc.dll" & ".tmp", VCSPkgDir & "cslangsvc.dll", True
        On Error Goto 0
            
        Shell.Popup "Uninstall LINQ Enabled C# IDE Support was unsuccessful." & vbCrLf & _
                    "Some files that need to be restored are currently in use.", _
                    0, "Uninstall LINQ Enabled C# IDE Support", vbCritical
    Case Else
End Select

Private Function RestoreFile(FilePath)
    On Error Resume Next
    RestoreFile = 0
    If FileSystem.FileExists(FilePath & ".backup") Then
        If FileSystem.FileExists(FilePath) Then
           If CompareFileVersion(FileSystem.GetFileVersion(FilePath), FileSystem.GetFileVersion(FilePath & ".backup"), False) > 0 Then
               Exit Function
           End If
           FileSystem.CopyFile FilePath, FilePath & ".tmp", True
        End If

        FileSystem.CopyFile FilePath & ".backup", FilePath, True
        If Err <> 0 Then
            RestoreFile = Err.Number
        End If
        SetNotHiddenReadOnly FilePath
    End If
    On Error Goto 0
End Function

Private Function RegCheck(Key)
    Dim tmp
    tmp = Shell.RegRead(Key)
    If Err <> 0 Then
        RegCheck = False
    Else
        RegCheck = True
    End If
    On Error Goto 0
End Function

Private Sub SetNotHiddenReadOnly(FileName)
    If FileSystem.FileExists(FileName) Then
        Dim FileObject
        Set FileObject = FileSystem.GetFile(FileName)
        FileObject.Attributes = FileObject.Attributes And Not 7
    End If
End Sub

Public Function ShutdownUndesirableProcesses()

    On Error Resume Next
    Dim WinmgmtObject
    Set WinmgmtObject = GetObject("winmgmts:")
    If Err <> 0 Then
        ShutdownUndesirableProcesses = 0
        Exit Function
    End If
    On Error Goto 0

    Dim UndesirableProcesses
    Set UndesirableProcesses = WinmgmtObject.ExecQuery("select * from Win32_Process where Name='devenv.exe' or Name='vbexpress.exe' or Name='vcsexpress.exe' or Name='vwdexpress.exe'")

    If UndesirableProcesses.Count > 0 Then
        Dim UndesirableProcess
        For Each UndesirableProcess in UndesirableProcesses
            Select Case Shell.Popup("You must close " & UndesirableProcess.Name & " (ID = " & CStr(UndesirableProcess.ProcessId) & ") before running """ & "Install LINQ Enabled C# IDE Support" & """." & vbCrLf & _
                "Do you want to force the process to terminate now?" & vbCrLf & vbCrLf & _
                "WARNING: You may lose any unsaved data by clicking Yes.", 0, "Install LINQ Enabled C# IDE Support", vbYesNo + vbQuestion + vbDefaultButton2)
                Case 6
                    On Error Resume Next
                    If UndesirableProcess.Terminate() <> 0 Then
                        On Error Goto 0
                        Shell.Popup "Unable to terminate " & UndesirableProcess.Name & ".  Setup cannot continue.", 0, "Install LINQ Enabled C# IDE Support", vbCritical
                        ShutdownUndesirableProcesses = 2
                        Exit Function
                    End If
                    On Error Goto 0
                Case Else
                    ShutdownUndesirableProcesses = 2
                    Exit Function
            End Select
        Next
    End If

    ShutdownUndesirableProcesses = 1
    On Error Goto 0
End Function

Private Function CompareFileVersion(FileVersion1, FileVersion2, ConsiderRevisionNumber)
    Dim VerRegExp
    Set VerRegExp = New RegExp
    VerRegExp.Global = True
    VerRegExp.Pattern = "[^\.]+"
    
    Dim Ver1
    Set Ver1 = VerRegExp.Execute(FileVersion1)

    Dim Ver2
    Set Ver2 = VerRegExp.Execute(FileVersion2)

    CompareFileVersion = -1
    If CLng(Ver1(0)) = CLng(Ver2(0)) Then
        If CLng(Ver1(1)) = CLng(Ver2(1)) Then
            If CLng(Ver1(2)) = CLng(Ver2(2)) Then
                If ConsiderRevisionNumber Then
                    If CLng(Ver1(3)) = CLng(Ver2(3)) Then
                        CompareFileVersion = 0
                    Else
                        If CLng(Ver1(3)) > CLng(Ver2(3)) Then
                            CompareFileVersion = 1
                        End If
                    End If
                Else
                    CompareFileVersion = 0
                End If
            Else
                If CLng(Ver1(2)) > CLng(Ver2(2)) Then
                    CompareFileVersion = 1
                End If
            End If
        Else
            If CLng(Ver1(1)) > CLng(Ver2(1)) Then
                CompareFileVersion = 1
            End If
        End If
    Else
        If CLng(Ver1(0)) > CLng(Ver2(0)) Then
            CompareFileVersion = 1
        End If
    End If
End Function